// Injection Wizard
// --An application for injecting traffic in WEP protected Wi-Fi networks--
// Version: 1.0
// Copyright (C) 2010 Fernando Pablo Romero Navarro <fernpromero@gmail.com>
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package cliente;

import java.awt.event.*;
import javax.swing.JOptionPane;
import java.io.IOException;
import java.util.ResourceBundle;


public class AcceptSt5Listener implements ActionListener, MsgSubscriber{

    private MainWindow window=null;

    public AcceptSt5Listener(MainWindow mainwin){
        this.window=mainwin;
    }

    public void actionPerformed(ActionEvent evt){
        CommClient commcli=window.getCommClient();
        ResourceBundle bundle=window.getBundle();
        String err=bundle.getString("ERR"), msgerr=null;
        boolean msgsend=false;
        byte[] response=null;

        try{
            commcli.sendMsg(new byte[]{Msg.INJECT});
            msgsend=true;
            response=commcli.getResponse();
            if(response[1]==Msg.DOING){
                window.enableAccept(false);
                window.enableCancel(true);
            }else
                throw new IllegalStateException("Error code:" +response[2]);

        }catch(IOException io){
            io.printStackTrace(System.err);
            msgerr=null;
            if(msgsend)
                msgerr=bundle.getString("ERR_NORESPONSE");
            else
                msgerr=bundle.getString("ERR_BREAKCONNECT");

            JOptionPane.showMessageDialog(window, msgerr, err,
                                          JOptionPane.ERROR_MESSAGE);

        }catch(IllegalStateException ile){
            ile.printStackTrace(System.err);
            msgerr=bundle.getString("ERR_SERVER");
            JOptionPane.showMessageDialog(window, msgerr, err,
                                          JOptionPane.ERROR_MESSAGE);
        }
        
    }


    
    public void deliverMsg(byte[] msg){        
        ResourceBundle bdle=window.getBundle();        

        if(msg[0]==Msg.INFO){

            if(msg[2]==Msg.CANCELLED){
                Runnable runcancel=null;
                final String msginf1=bdle.getString("INF_CANC");
                final String msginf2=bdle.getString("INF_INJECT");
                runcancel=new Runnable(){
                                public void run(){
                                    window.enableCancel(false);
                                    window.enableAccept(true);
                                    window.reportUser(MainWindow.TYPEINFO,
                                                      msginf1);
                                    window.reportUser(MainWindow.TYPEINFO,
                                                      msginf2);
                                }
                            };

                MainWindow.updateWindow(runcancel);
            }else if(msg[2]==Msg.FRAMES){
                StringBuffer stats=new StringBuffer(16);
                stats.append(bdle.getString("INF_FRAMES"));
                stats.append(' ');
                String tmp=MsgOptParser.getString(msg, 3, msg.length-3);
                if(tmp!=null)
                    stats.append(tmp);
                else
                    stats.append("??/??");

                final String msginfo=stats.toString();
                MainWindow.updateWindow(
                        new Runnable(){
                            public void run(){
                                window.reportUser(MainWindow.TYPEINFO, msginfo);
                            }
                        });               
            }
        }
    }

    public int getSource(){
        return ((int)Msg.INJECTARP) & 0xFF;
    }
}
