// Injection Wizard
// --An application for injecting traffic in WEP protected Wi-Fi networks--
// Version: 1.0
// Copyright (C) 2010 Fernando Pablo Romero Navarro <fernpromero@gmail.com>
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package cliente;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.border.*;
import java.nio.ByteBuffer;


public class MainWindow extends JFrame{

    public final static int TYPEERROR=-1;
    public final static int TYPEINFO=0;

    private final static byte[]
            MSGNEXT={Msg.SET, 0x73, 0x74, 0x61, 0x67, 0x65,
                     Msg.VALUE_SEP, Msg.STAGE_NEXT, Msg.ITEM_SEP};
    
    
    private int clistage=0;
    private ClientConf config=null;
    private ResourceBundle text=null;
    private CommClient comm=null;
    private java.util.List<BSSInfo> bsscan=null;
    private int bssindex=-1;
    private boolean contactdone=false;

    private JMenuBar menubar=null;
    private JMenu configmenu=null;
    private JMenu screenmenu=null;
    private JMenu exitmenu=null;
    private JTextArea msgarea=null;
    private JTextField jTfessid=null;
    private JTextField jTfbssid=null;
    private JTextField jTfchan=null;
    private JTextField jTfsnr=null;
    private JTextField jTfqlty=null;
    private JButton jBtnscan=null;
    private JButton jBtnprev=null;
    private JButton jBtnnext=null;
    private JButton jBtnOk=null;
    private JButton jBtnCanc=null;
    private JButton jBtnRinc=null;
    private JProgressBar progress=null;
    private JLabel jLbprg=null;

    private class ExitAction extends AbstractAction{
        private byte exitcmd=Msg.DISCONNECT;
        
        public ExitAction(String text, String descr, byte exitcommand){
            super(text);
            putValue(Action.SHORT_DESCRIPTION, descr);
            exitcmd=exitcommand;            
        }
        public void actionPerformed(ActionEvent evt){
            int status=0;
            try{
                if(contactdone){
                    comm.sendMsg(new byte[]{exitcmd});
                    comm.getResponse();
                    comm.release();
                }
            }catch(IOException io){
                String errmsg=text.getString("ERR_DISCONNECT");
                System.err.println(errmsg);
                io.printStackTrace(System.err);
                status=1;
            }finally{                                  
                 dispose();
                 System.exit(status);
            }
        }
    }

    private class CloseWindow extends WindowAdapter{
        private Action closeAct=null;
        public CloseWindow(Action closeaction){
            closeAct=closeaction;
        }
        @Override
        public void windowClosing(WindowEvent e) {
            ActionEvent actevt=null;
            actevt=new ActionEvent(e.getSource(), e.getID(), "Exit");
            closeAct.actionPerformed(actevt);
        }
    }
    
    private Dimension maxdim(Dimension[] dims, int dir){
        Dimension maxdim=new Dimension(0,0);

        if(dir==SwingConstants.HORIZONTAL){
            for(Dimension dim:dims)
                if(dim.getWidth() > maxdim.getWidth())
                    maxdim=dim;
        }else if(dir==SwingConstants.VERTICAL){
            for(Dimension dim:dims)
                if(dim.getHeight() > maxdim.getHeight())
                    maxdim=dim;
        }

        return maxdim;
    }

    public MainWindow(ClientConf cliconf, ResourceBundle txt){
        super(txt.getString("TITLE"));
        config=cliconf;
        text=txt;
        initComponents();
        initListeners();        
        pack();
        setResizable(true);
        setLocationRelativeTo(null);
    }

    private void initComponents(){
        JMenuItem menuitem=null;
        String lclb=null;
        String tip=null;
        Border border=null;
        menubar=new JMenuBar();
        setJMenuBar(menubar);

        
        lclb=text.getString("MENUCONFIG");
        configmenu=new JMenu(lclb);

        lclb=text.getString("MENUSERVER");
        menuitem=new JMenuItem(lclb);
        tip=text.getString("TIPSERVER");
        menuitem.setToolTipText(tip);
        configmenu.add(menuitem);

        lclb=text.getString("MENUIFACE");
        menuitem=new JMenuItem(lclb);
        tip=text.getString("TIPIFACE");        
        menuitem.setToolTipText(tip);
        configmenu.add(menuitem);

        lclb=text.getString("MENUSUBNET");
        menuitem=new JMenuItem(lclb);
        tip=text.getString("TIPSUBNET");
        menuitem.setToolTipText(tip);
        configmenu.add(menuitem);

        lclb=text.getString("MENUERROR");
        menuitem=new JMenuItem(lclb);
        tip=text.getString("TIPERROR");
        menuitem.setToolTipText(tip);
        configmenu.add(menuitem);

        lclb=text.getString("MENUSAVE");
        menuitem=new JMenuItem(lclb);
        tip=text.getString("TIPSAVE");
        menuitem.setToolTipText(tip);
        configmenu.add(menuitem);
        menubar.add(configmenu);

        
        lclb=text.getString("MENUSCREEN");
        screenmenu=new JMenu(lclb);
        lclb=text.getString("MENUCLEAR");
        menuitem=new JMenuItem(lclb);
        tip=text.getString("TIPCLEAR");        
        menuitem.setToolTipText(tip);
        screenmenu.add(menuitem);

        lclb=text.getString("MENUSTART");
        menuitem=new JMenuItem(lclb);
        tip=text.getString("TIPSTART");
        menuitem.setToolTipText(tip);
        screenmenu.add(menuitem);

        lclb=text.getString("MENUEND");
        menuitem=new JMenuItem(lclb);
        tip=text.getString("TIPEND");
        menuitem.setToolTipText(tip);
        screenmenu.add(menuitem);
        menubar.add(screenmenu);
        menubar.add(Box.createHorizontalGlue());
        
        
        lclb=text.getString("MENUEXIT");
        exitmenu=new JMenu(lclb);

        lclb=text.getString("MENUABOUT");
        menuitem=new JMenuItem(lclb);
        tip=text.getString("TIPABOUT")+" "+text.getString("TITLE");
        menuitem.setToolTipText(tip);
        exitmenu.add(menuitem);

        lclb=text.getString("MENUQUIT");
        menuitem=new JMenuItem(lclb);
        tip=text.getString("TIPQUIT");
        menuitem.setToolTipText(tip);
        exitmenu.add(menuitem);

        lclb=text.getString("MENUTERM");
        menuitem=new JMenuItem(lclb);
        tip=text.getString("TIPTERM");
        menuitem.setToolTipText(tip);
        exitmenu.add(menuitem);
        menubar.add(exitmenu);
        

        Container contentPane=this.getContentPane();
        contentPane.setLayout(new BorderLayout(5, 5));
        
        contentPane.add(Box.createRigidArea(new Dimension(0, 5)),
                        BorderLayout.PAGE_START);

        
        JScrollPane scroll=null;
        msgarea=new JTextArea(20,40);
        msgarea.setEditable(false);
        msgarea.setLineWrap(true);
        msgarea.setWrapStyleWord(true);

        lclb=text.getString("MSGPANELTITLE");
        border=BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder(lclb),
                                BorderFactory.createLoweredBevelBorder());

        
        scroll=new JScrollPane(msgarea,
                               JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                               JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        
        scroll.setBorder(border);        
        contentPane.add(scroll, BorderLayout.CENTER);


        
        JPanel jPeast=new JPanel();
        jPeast.setLayout(new BoxLayout(jPeast, BoxLayout.PAGE_AXIS));

        
        JPanel jPeastup=new JPanel();
        jPeastup.setLayout(new BoxLayout(jPeastup, BoxLayout.PAGE_AXIS));
        lclb=text.getString("SELPANELTITLE");
        border=BorderFactory.createTitledBorder(lclb);
        jPeastup.setBorder(border);
        jPeastup.add(Box.createRigidArea(new Dimension(0, 5)));       
        JPanel jPtop=new JPanel(new SpringLayout());        
        JLabel label=null;
        lclb=text.getString("LABELNETID");
        label=new JLabel(lclb);
        jPtop.add(label);
        jTfessid=new JTextField();
        jTfessid.setEditable(false);
        tip=text.getString("TIPESSID");
        jTfessid.setToolTipText(tip);        
        label.setLabelFor(jTfessid);
        jPtop.add(jTfessid);
        SpringUtilities.makeCompactGrid(jPtop, 2, 1, 5, 5, 5, 5);       
        jPeastup.add(jPtop);
        jPtop.setAlignmentX(Component.LEFT_ALIGNMENT);
        
        
        JPanel jPeastmiddle=new JPanel(new BorderLayout());

        JPanel jPmidright=new JPanel();
        GridBagLayout grid=new GridBagLayout();
        GridBagConstraints cons=new GridBagConstraints();
        jPmidright.setLayout(grid);
        Dimension dim=null;

        cons.gridx=0;
        cons.gridy=0;
        cons.gridwidth=2;
        cons.weighty=0.0;
        cons.insets=new Insets(5,5,5,5);
        cons.fill=GridBagConstraints.HORIZONTAL;
        lclb=text.getString("BUTTONSCAN");
        jBtnscan=new JButton(lclb);
        grid.setConstraints(jBtnscan, cons);
        jPmidright.add(jBtnscan);

        cons.gridx=0;
        cons.gridy=1;
        cons.gridwidth=1;
        cons.weighty=0;
        cons.fill=GridBagConstraints.NONE;
        jBtnprev=new JButton("<<");
        tip=text.getString("TIPPREVBSS");
        jBtnprev.setToolTipText(tip);
        grid.setConstraints(jBtnprev, cons);
        jPmidright.add(jBtnprev);

        cons.gridx=1;
        cons.gridy=1;
        cons.gridwidth=0;
        jBtnnext=new JButton(">>");
        tip=text.getString("TIPNEXTBSS");
        jBtnnext.setToolTipText(tip);
        grid.setConstraints(jBtnnext, cons);
        jPmidright.add(jBtnnext);

        cons.gridx=1;
        cons.gridy=2;
        cons.fill=GridBagConstraints.VERTICAL;
        cons.weighty=1.0;
        Component padding=Box.createVerticalGlue();
        grid.setConstraints(padding, cons);
        jPmidright.add(padding);
        dim=jBtnscan.getPreferredSize();
        int width=(int)dim.getWidth();
        int height=(int)dim.getHeight();
        width+=width/5;
        dim=new Dimension(width, height );

        JPanel jPmidleft=new JPanel(new SpringLayout());
        jPmidleft.setAlignmentX(Component.RIGHT_ALIGNMENT);        
        lclb=text.getString("LABELBSSID");
        label=new JLabel(lclb);
        jPmidleft.add(label);
        jTfbssid=new JTextField();
        jTfbssid.setPreferredSize(dim);
        jTfbssid.setMaximumSize(dim);
        jTfbssid.setEditable(false);
        tip=text.getString("TIPBSSID");
        jTfbssid.setToolTipText(tip);
        label.setLabelFor(jTfbssid);
        jPmidleft.add(jTfbssid);

        lclb=text.getString("LABELCHAN");
        label=new JLabel(lclb);
        jPmidleft.add(label);
        jTfchan=new JTextField();
        jTfchan.setEditable(false);
        jTfchan.setPreferredSize(dim);
        jTfchan.setMaximumSize(dim);
        tip=text.getString("TIPCHAN");
        jTfchan.setToolTipText(tip);
        label.setLabelFor(jTfchan);
        jPmidleft.add(jTfchan);

        lclb=text.getString("LABELSNR");
        label=new JLabel(lclb);
        jPmidleft.add(label);
        jTfsnr=new JTextField();
        jTfsnr.setEditable(false);
        jTfsnr.setPreferredSize(dim);
        jTfsnr.setMaximumSize(dim);
        tip=text.getString("TIPSNR");
        jTfsnr.setToolTipText(tip);
        label.setLabelFor(jTfsnr);
        jPmidleft.add(jTfsnr);

        lclb=text.getString("LABELQLTY");
        label=new JLabel(lclb);
        jPmidleft.add(label);
        jTfqlty=new JTextField();
        jTfqlty.setEditable(false);
        jTfqlty.setPreferredSize(dim);
        jTfqlty.setMaximumSize(dim);
        tip=text.getString("TIPQLTY");
        jTfqlty.setToolTipText(tip);
        label.setLabelFor(jTfqlty);
        jPmidleft.add(jTfqlty);        
        SpringUtilities.makeCompactGrid(jPmidleft, 4, 2, 5, 5, 10, 10);
                        
        jPeastmiddle.add(jPmidleft, BorderLayout.LINE_START);
        jPeastmiddle.add(jPmidright, BorderLayout.CENTER);
        jPeastmiddle.setAlignmentX(Component.LEFT_ALIGNMENT);
        jPeastup.add(jPeastmiddle);        
                
        
        JPanel jPeastdown=new JPanel();
        jPeastdown.setLayout(new BoxLayout(jPeastdown, BoxLayout.PAGE_AXIS));
        lclb=text.getString("PRGPANELTITLE");        
        border=BorderFactory.createCompoundBorder(
                    BorderFactory.createTitledBorder(lclb),
                    BorderFactory.createEmptyBorder(10, 5, 20, 5));
        jPeastdown.setBorder(border);        
        lclb=text.getString("STAGE0");
        jLbprg=new JLabel(lclb);
        jLbprg.setLabelFor(progress);
        jPeastdown.add(jLbprg);
        jPeastdown.add(Box.createRigidArea(new Dimension(0, 5)));
        progress=new JProgressBar(0,5);
        progress.setValue(0);
        progress.setStringPainted(true);
        jPeastdown.add(progress);
        
        jPeast.add(jPeastup);
        jPeastup.setAlignmentX(Component.LEFT_ALIGNMENT);        
        jPeast.add(jPeastdown);
        jPeastdown.setAlignmentX(Component.LEFT_ALIGNMENT);
        contentPane.add(jPeast, BorderLayout.LINE_END);

        
        JPanel jPbtns=new JPanel();
        jPbtns.setLayout(new BoxLayout(jPbtns, BoxLayout.LINE_AXIS));
        jPbtns.setBorder(
                BorderFactory.createEmptyBorder(15, 0, 15, 0));

        Dimension sep=new Dimension(100, 0);
        Dimension dim1, dim2, dim3;
        lclb=text.getString("BUTTONOK");
        jBtnOk=new JButton(lclb);
        dim1=jBtnOk.getPreferredSize();
        jPbtns.add(jBtnOk);
       
        jPbtns.add(Box.createRigidArea(sep));
        lclb=text.getString("BUTTONCANCEL");
        jBtnCanc=new JButton(lclb);
        dim2=jBtnCanc.getPreferredSize();
        jPbtns.add(jBtnCanc);

        jPbtns.add(Box.createRigidArea(sep));
        lclb=text.getString("BUTTONINIT");
        jBtnRinc=new JButton(lclb);
        jPbtns.add(jBtnRinc);
        dim3=jBtnRinc.getPreferredSize();
        dim=this.maxdim(new Dimension[]{dim1, dim2, dim3},
                        SwingConstants.HORIZONTAL);
        
        jBtnOk.setPreferredSize(dim);
        jBtnCanc.setPreferredSize(dim);
        jBtnRinc.setPreferredSize(dim);

        jBtnOk.setMaximumSize(dim);
        jBtnCanc.setMaximumSize(dim);
        jBtnRinc.setMaximumSize(dim);

        JPanel jPsouth=new JPanel();
        jPsouth.setBorder(
                BorderFactory.createCompoundBorder(
                    BorderFactory.createEmptyBorder(5, 0, 5, 0),
                    BorderFactory.createTitledBorder("")));                

        jPsouth.setLayout(new GridBagLayout());
        cons=new GridBagConstraints();
        cons.gridx=0;
        cons.gridy=0;
        cons.gridheight=2;
        cons.fill=GridBagConstraints.HORIZONTAL;
        cons.weightx=1.0;
        jPsouth.add(new JPanel(), cons);

        cons.gridx=4;
        jPsouth.add(new JPanel(), cons);

        cons.gridx=1;
        cons.gridy=1;
        cons.gridwidth=3;
        cons.gridheight=2;
        cons.weightx=0.;
        jPsouth.add(jPbtns, cons);        

        contentPane.add(jPsouth, BorderLayout.PAGE_END);
    }

    private void initListeners(){
        ExitAction exitaction=null;
        JMenuItem menuitem=null;
        String menutext=null, tip=null;
        
        menuitem=exitmenu.getItem(0);
        menutext=menuitem.getText();        
        if(menutext.equals(text.getString("MENUABOUT"))){
            final String title=menutext;
            menuitem.addActionListener(
                        new ActionListener(){
                            public void actionPerformed(ActionEvent evt){
                                new AboutDialog(MainWindow.this, title);
                            }
                        });
        }

        menuitem=exitmenu.getItem(1);
        menutext=menuitem.getText();
        tip=menuitem.getToolTipText();
        exitaction=new ExitAction(menutext, tip, Msg.DISCONNECT);
        if(menutext.equals(text.getString("MENUQUIT")))
            menuitem.setAction(exitaction);       

        addWindowListener(new CloseWindow(exitaction));
        
        menuitem=exitmenu.getItem(2);
        menutext=menuitem.getText();
        tip=menuitem.getToolTipText();
        exitaction=new ExitAction(menutext, tip, Msg.EXIT);
        if(menutext.equals(text.getString("MENUTERM")))
            menuitem.setAction(exitaction);

        menuitem=screenmenu.getItem(0);
        if(menuitem.getText().equals(text.getString("MENUCLEAR")))
            menuitem.addActionListener(
                        new ActionListener(){
                            public void actionPerformed(ActionEvent evt){
                                msgarea.setText("");
                            }
                        });

        menuitem=screenmenu.getItem(1);
        if(menuitem.getText().equals(text.getString("MENUSTART")))
            menuitem.addActionListener(
                    new ActionListener(){
                            public void actionPerformed(ActionEvent evt){                                
                                msgarea.setCaretPosition(0);
                            }
                        });

        menuitem=screenmenu.getItem(2);
        if(menuitem.getText().equals(text.getString("MENUEND")))
            menuitem.addActionListener(
                    new ActionListener(){
                            public void actionPerformed(ActionEvent evt){
                                Document doc=msgarea.getDocument();
                                int pos=doc.getLength();
                                msgarea.setCaretPosition(pos);
                            }
                        });

        menuitem=configmenu.getItem(0);
        if(menuitem.getText().equals(text.getString("MENUSERVER")))
            menuitem.addActionListener(
                    new ActionListener(){
                        public void actionPerformed(ActionEvent evt){
                            ServerDialog sd=null;
                            sd=new ServerDialog(MainWindow.this, text, config);
                            if(sd.isValidated()){
                                config.setIP(sd.getIP());
                                config.setPort(sd.getPort());
                                MainWindow.this.contact_init(true);
                            }
                        }
            });


        menuitem=configmenu.getItem(1);        
        if(menuitem.getText().equals(text.getString("MENUIFACE")))
            menuitem.addActionListener(
                        new MenuInterfaceListener(MainWindow.this));


        menuitem=configmenu.getItem(2);
        if(menuitem.getText().equals(text.getString("MENUSUBNET")))
            menuitem.addActionListener(
                        new MenuSubnetListener(MainWindow.this));

        menuitem=configmenu.getItem(3);
        if(menuitem.getText().equals(text.getString("MENUERROR")))
            menuitem.addActionListener(
                        new MenuErrorListener(MainWindow.this));

        menuitem=configmenu.getItem(4);
        if(menuitem.getText().equals(text.getString("MENUSAVE")))
            menuitem.addActionListener(
                    new ActionListener(){
                        public void actionPerformed(ActionEvent evt){
                            boolean ok=config.save();
                            if(ok)
                                MainWindow.this.reportUser(
                                                MainWindow.TYPEINFO,
                                                text.getString("INF_SAVE"));
                            else
                                MainWindow.this.reportUser(
                                                MainWindow.TYPEERROR,
                                                text.getString("ERR_SAVE"));
                        }
                    });

        jBtnscan.addActionListener(new ScanListener(this));

        jBtnprev.addActionListener(
                    new ActionListener(){
                        public void actionPerformed(ActionEvent evt){
                            if(bsscan!=null && bsscan.size()>1){
                                int sz=bsscan.size();
                                if(bssindex<=0 || bssindex>=sz)
                                    bssindex=sz-1;
                                else
                                    bssindex--;

                                updateBSSInfo(bsscan.get(bssindex));
                            }
                        }
        });

        jBtnnext.addActionListener(
                    new ActionListener(){
                        public void actionPerformed(ActionEvent evt){
                            if(bsscan!=null && bsscan.size()>1){
                                int sz=bsscan.size();
                                if(bssindex<0 || bssindex>=sz-1)
                                    bssindex=0;
                                else
                                    bssindex++;

                                updateBSSInfo(bsscan.get(bssindex));
                            }
                        }
        });

        jBtnRinc.addActionListener(new RestartListener(this));
    }

    private void setButtonListener(JButton button, ActionListener listener){
        ActionListener[] lst=button.getActionListeners();
        for(ActionListener listen: lst)
            button.removeActionListener(listen);
        
        button.addActionListener(listener);
    }

    private void updateBSSInfo(BSSInfo bss){
        
        String strvalue=null;
        int intval=0;
        strvalue=bss.getEssid();
        jTfessid.setText(strvalue==null? "":strvalue);
        

        strvalue=bss.getBssid();
        jTfbssid.setText(strvalue==null? "":strvalue.toUpperCase());

        intval=bss.getChannel();
        if(intval>0 && intval<15)
            strvalue=Integer.toString(intval);
        else
            strvalue="";
        jTfchan.setText(strvalue);

        intval=bss.getSnr();
        if(intval>-10 && intval<256)
            strvalue=Integer.toString(intval);
        else
            strvalue="";
        jTfsnr.setText(strvalue!=null? strvalue : "");

        intval=bss.getQuality();
        if(intval>-1 && intval<101)
            strvalue=Integer.toString(intval);
        else
            strvalue="";
        jTfqlty.setText(strvalue!=null? strvalue : "");
    }

    public void updateESSID(final String essid){
        if(bsscan!=null && bssindex>-1 && bssindex<bsscan.size()){
            BSSInfo bss=bsscan.get(bssindex);
            bss.setEssid(essid);
            jTfessid.setText(essid);                            
        }
    }

    public void setScanInfo(java.util.List<BSSInfo> scinfo){
        bsscan=scinfo;
        bssindex=0;
        updateBSSInfo(bsscan.get(0));
    }

    private void disableControls(){
        configmenu.setEnabled(false);
        jBtnscan.setEnabled(false);
        jBtnnext.setEnabled(false);
        jBtnprev.setEnabled(false);
        jBtnOk.setEnabled(false);
        jBtnCanc.setEnabled(false);
        jBtnRinc.setEnabled(false);
        jTfessid.setText("");
        jTfbssid.setText("");
        jTfchan.setText("");
        jTfsnr.setText("");
        jTfqlty.setText("");
    }

    public void enableAccept(boolean enable){
        jBtnOk.setEnabled(enable);
    }

    public void enableCancel(boolean enable){
        jBtnCanc.setEnabled(enable);
    }

    public void enableScan(boolean enable){
        jBtnscan.setEnabled(enable);
        jBtnnext.setEnabled(enable);
        jBtnprev.setEnabled(enable);
    }

    public void initialStage(){
        disableControls();
        String stlb=text.getString("STAGE0");
        jLbprg.setText(stlb);
        progress.setValue(0);
        setButtonListener(jBtnOk, new AcceptSt0Listener(this));
        clistage=0;
        bsscan=null;
        bssindex=-1;
        configmenu.setEnabled(true);
        jBtnOk.setEnabled(true);
    }

    public void nextStage() throws IOException{
        byte[] response=null;

        comm.sendMsg(MSGNEXT);
        response=comm.getResponse();
        
        if(response[1]==Msg.OK){
            
            switch(clistage){
                case 0:
                    configmenu.setEnabled(false);
                    jBtnRinc.setEnabled(true);
                    gotoStage(1, false);                    
                    break;

                case 1:
                    jBtnCanc.setEnabled(false);
                    gotoStage(2, false);
                    break;

                case 2:
                    jBtnCanc.setEnabled(false);
                    gotoStage(3 ,false);
                    break;

                case 3:
                    jBtnCanc.setEnabled(false);
                    gotoStage(4 ,false);
                    break;

                case 4:
                    jBtnCanc.setEnabled(false);
                    gotoStage(5 ,false);
                    break;

                default:
                    break;
            }
        }else
            throw new IllegalStateException("Error code:"+response[2]);
    }

    private void gotoStage(int stage, boolean begun){
        String msginfo=null;
        clistage=stage;
        progress.setValue(stage);
        
        switch(stage){
            case 1:
                jLbprg.setText(text.getString("STAGE1"));
                AcceptSt1Listener accp1Lstn=new AcceptSt1Listener(this);
                setButtonListener(jBtnOk, accp1Lstn);
                setButtonListener(jBtnCanc, new CancelSt1Listener(this));
                comm.setSubscriber(MsgSubscriber.INFO_SUBSCRIBER, accp1Lstn);

                if(begun)
                    jBtnCanc.setEnabled(true);
                else{
                    jBtnscan.setEnabled(true);
                    jBtnprev.setEnabled(true);
                    jBtnnext.setEnabled(true);
                    jBtnOk.setEnabled(true);
                }
                break;

            case 2:
                jLbprg.setText(text.getString("STAGE2"));                
                AcceptSt2Listener accp2Lstn=new AcceptSt2Listener(this);
                setButtonListener(jBtnOk, accp2Lstn);
                setButtonListener(jBtnCanc, new CancelListener(this, msginfo));
                comm.setSubscriber(MsgSubscriber.INFO_SUBSCRIBER, accp2Lstn);
                comm.setSubscriber(MsgSubscriber.ASK_SUBSCRIBER, accp2Lstn);
                
                if(begun)
                    jBtnCanc.setEnabled(true);
                else{
                    msginfo=text.getString("INF_CAPT");
                    reportUser(TYPEINFO, msginfo);
                    jBtnOk.setEnabled(true);
                }
                break;

            case 3:
                jLbprg.setText(text.getString("STAGE3"));                
                AcceptSt3Listener accp3Lstn=new AcceptSt3Listener(this);
                setButtonListener(jBtnOk, accp3Lstn);
                setButtonListener(jBtnCanc, new CancelListener(this, msginfo));
                comm.setSubscriber(MsgSubscriber.INFO_SUBSCRIBER, accp3Lstn);
                comm.setSubscriber(MsgSubscriber.ASK_SUBSCRIBER, accp3Lstn);

                if(begun)
                    jBtnCanc.setEnabled(true);
                else{
                    msginfo=text.getString("INF_ATTACK");
                    reportUser(TYPEINFO, msginfo);
                    jBtnOk.setEnabled(true);
                }
                break;

            case 4:
                jLbprg.setText(text.getString("STAGE4"));                
                AcceptSt4Listener accp4Lstn=new AcceptSt4Listener(this);
                setButtonListener(jBtnOk, accp4Lstn);
                setButtonListener(jBtnCanc, new CancelListener(this, msginfo));
                comm.setSubscriber(MsgSubscriber.INFO_SUBSCRIBER, accp4Lstn);
                comm.setSubscriber(MsgSubscriber.ASK_SUBSCRIBER, accp4Lstn);

                if(begun)
                    jBtnCanc.setEnabled(true);
                else{
                    msginfo=text.getString("INF_FIND");
                    reportUser(TYPEINFO, msginfo);
                    jBtnOk.setEnabled(true);
                }
                break;

            case 5:
                jLbprg.setText(text.getString("STAGE5"));                
                AcceptSt5Listener accp5Lstn=new AcceptSt5Listener(this);
                setButtonListener(jBtnOk, accp5Lstn);
                setButtonListener(jBtnCanc, new CancelListener(this, msginfo));
                comm.setSubscriber(MsgSubscriber.INFO_SUBSCRIBER, accp5Lstn);

                if(begun)
                    jBtnCanc.setEnabled(true);
                else{
                    msginfo=text.getString("INF_INJECT");
                    reportUser(TYPEINFO, msginfo);
                    jBtnOk.setEnabled(true);
                }
                break;

            default:
                break;
        }
    }

    private void setConfigSubmenusEnable(boolean enable, boolean disableserv){
        JMenuItem submenu=null;

        for(int i=1; i<configmenu.getItemCount(); i++){
            submenu=configmenu.getItem(i);
            if(submenu!=null)
                submenu.setEnabled(enable);
        }

        if(enable == disableserv){
            submenu=configmenu.getItem(0);
            if(submenu.getText().equals(text.getString("MENUSERVER"))){
                submenu.setEnabled(!disableserv);
            }
        }

        configmenu.repaint();
    }

    
    public void contact_init(boolean showerrors){
        HashMap map=null;
        String ip=null;
        int port=0;
        Integer st=null;
        boolean connected=false;
        boolean enableconfig=false;
        byte[] resp=null;

        try{            
            if(comm!=null)
                comm.release();

            ip=config.getIP();
            port=config.getPort();
            comm=new CommClient();
            contactdone=false;
            comm.setServerAddress(ip, port);
            connected=true;

            comm.sendMsg(new byte[]{Msg.HELLO});
            resp=comm.getResponse();           
            contactdone=true;
            config.setIP(ip);
            config.setPort(port);

            String msg=String.format("%s: %s:%d", text.getString("INF_CONNECT"),
                                     ip, port);
            
            reportUser(TYPEINFO, msg);            
            

            if(resp[1]==Msg.OK){
                map=MsgOptParser.parseConfigOpts(resp, 2, resp.length-2);
                st=(Integer)map.get(Msg.STAGE);
                if(st!=null && st.intValue()>0)
                    serverSynchro(map);
                else
                    enableconfig=true;
            }else
                enableconfig=true;
            
            if(enableconfig){
                setConfigSubmenusEnable(true, contactdone);
                enableAccept(true);
            }
            
        }catch(IOException io){
            String err=text.getString("ERR");
            String errmsg=null;
            if(!connected){
                if(showerrors){
                    errmsg=text.getString("ERR_NOCONNECT");
                    JOptionPane.showMessageDialog(this, errmsg, err,
                                                  JOptionPane.ERROR_MESSAGE);
                }else
                    System.err.println(
                            "Server address in configuration file is no valid");
                
            }else if(!contactdone){
                if(showerrors){
                    errmsg=text.getString("ERR_NORESPONSE");
                    JOptionPane.showMessageDialog(this, errmsg, err,
                                                  JOptionPane.ERROR_MESSAGE);
                }
                else
                    System.err.println("Server response has not been received");
            }
            
            setConfigSubmenusEnable(false, false);
            jBtnOk.setEnabled(false);
        }
    }

    private void serverSynchro(HashMap map){        
        int stage=((Integer)map.get(Msg.STAGE)).intValue();
        final boolean begun=(stage>128);
        
        config.update(map);
        disableControls();
        jBtnRinc.setEnabled(true);
        
        if(stage>1)
            try{
                byte[] resp=null;
                comm.sendMsg(new byte[]{Msg.GETBSS});
                resp=comm.getResponse();

                if(resp[1]==Msg.OK){
                    java.util.List<BSSInfo> lst=null;
                    lst=MsgOptParser.parseScanInfo(resp, 2, resp.length-2);
                    BSSInfo bss=lst.get(0);
                    updateBSSInfo(bss);
                }else
                    throw new IOException("No BSS received");
                
            }catch(IOException io){
                io.printStackTrace(System.err);
            }

        int finalstage;
        if(begun)
            finalstage=stage-128;
        else
            finalstage=stage;
       
       gotoStage(finalstage, begun);       
    }
 
    public ClientConf getConfig(){
        return config;
    }

    public ResourceBundle getBundle(){
        return text;
    }

    public CommClient getCommClient(){
        return comm;
    }

    public BSSInfo getSelectedBSS(){
        if(bsscan==null || bssindex<0 || bssindex>=bsscan.size())
            return null;
        else
            return bsscan.get(bssindex);
    }

    public void reportUser(int type, String message){
        String prefix=null;

        if(type==TYPEERROR)
            prefix=text.getString("ERR").toUpperCase();
        else if(type==TYPEINFO)
            prefix=text.getString("INF").toUpperCase();

        if(prefix==null)
            prefix="";
        else
            prefix+=":: ";

        msgarea.append(prefix+message+".\n");
        msgarea.repaint();
    }

    public String[] listIfaces(){
        String[] ifaces=null;
        byte[] resp=null;

        if(contactdone)
            try{
                ByteBuffer buf=MsgOptParser.getBytes(Msg.IFACES);
                buf.rewind();
                int len=buf.remaining();
                byte[] request=new byte[len+1];
                request[0]=Msg.GET;
                buf.get(request, 1, len);
                comm.sendMsg(request);
                resp=comm.getResponse();
                len=resp.length;

                if(resp[1]==Msg.NONE)
                    ifaces=new String[0];
                else if(resp[1]==Msg.SERVER_ERROR)
                    throw new IOException("Server error, code: "+resp[2]);
                else if(resp[1]==Msg.OK)
                    ifaces=MsgOptParser.parseInterfaceList(resp, 2, len-2);
                
            }catch(IOException io){
                System.err.println("Error in listIfaces");
                io.printStackTrace(System.err);
            }        
        return ifaces;
    }

    public static void updateWindow(Runnable updater){
        SwingUtilities.invokeLater(updater);
    }

    public void showAnnouncement(){
        final String aboutitle=text.getString("MENUABOUT");
        new AboutDialog(MainWindow.this, aboutitle);
    }
}
