// Injection Wizard
// --An application for injecting traffic in WEP protected Wi-Fi networks--
// Version: 1.0
// Copyright (C) 2010 Fernando Pablo Romero Navarro <fernpromero@gmail.com>
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package cliente;

import java.awt.event.*;
import javax.swing.*;
import java.util.ResourceBundle;
import java.nio.ByteBuffer;
import java.io.IOException;


public class MenuInterfaceListener implements ActionListener{

    private final static int MAXREQUEST=128;
    private MainWindow window=null;
    public MenuInterfaceListener(MainWindow mw){
        window=mw;
    }

    public void actionPerformed(ActionEvent evt){
        String[] ifaces=null;
        String errmsg=null, err=null;
        ResourceBundle bundle=null;
        ByteBuffer buf=null;

        bundle=window.getBundle();
        ifaces=window.listIfaces();
        if (ifaces==null)
            errmsg=bundle.getString("ERR_NORESPONSE");
        else if(ifaces.length==0)
            errmsg=bundle.getString("ERR_IFACES");
        else{
            ClientConf config=window.getConfig();
            IfaceDialog ifdiag=new IfaceDialog(window, bundle, ifaces, config);
            if(ifdiag.isValidated()){
                String ifname=ifdiag.getSelInterface();
                boolean hasfcs=ifdiag.getHasFCS();
                int hdrindex=ifdiag.getHeaderIndex();
                byte[] resp=null, request=new byte[MAXREQUEST];
                int reqlen=0, offset=0;
                request[0]=Msg.SET;
                
                
                offset=++reqlen;
                buf=MsgOptParser.getBytes(Msg.WIFACE);
                buf.rewind();
                reqlen+=buf.remaining();
                buf.get(request, offset, reqlen-offset);
                offset=reqlen++;
                request[offset]=Msg.VALUE_SEP;
                offset=reqlen;
                buf=MsgOptParser.getBytes(ifname);
                buf.rewind();
                reqlen+=buf.remaining();
                buf.get(request, offset, reqlen-offset);
                offset=reqlen++;
                request[offset]=Msg.ITEM_SEP;
                offset=reqlen;
                
                
                buf=MsgOptParser.getBytes(Msg.FCS);
                buf.rewind();
                reqlen+=buf.remaining();
                buf.get(request, offset, reqlen-offset);
                offset=reqlen++;
                request[offset]=Msg.VALUE_SEP;
                offset=reqlen++;
                if(hasfcs)
                    request[offset]=1;
                else
                    request[offset]=0;

                offset=reqlen++;
                request[offset]=Msg.ITEM_SEP;
                offset=reqlen;


                buf=MsgOptParser.getBytes(Msg.MONHDR);
                buf.rewind();
                reqlen+=buf.remaining();
                buf.get(request, offset, reqlen-offset);
                offset=reqlen++;
                request[offset]=Msg.VALUE_SEP;
                offset=reqlen++;
                if(hdrindex==0)
                    request[offset]=Msg.AUTO;
                else
                    request[offset]=(byte)(hdrindex-1);

                offset=reqlen++;
                request[offset]=Msg.ITEM_SEP;
                offset=reqlen;

                CommClient commcli=window.getCommClient();
                
                try{
                    commcli.sendMsg(request, 0, reqlen);
                    resp=commcli.getResponse();
                    if(resp[1]==Msg.SERVER_ERROR){
                        if(resp[2]==Msg.IFACE_NOT_ENABLED)
                            errmsg=bundle.getString("ERR_IFACE_DOWN");
                        else if(resp[2]==Msg.MON_IFACE_NOT_CREATED)
                            errmsg=bundle.getString("ERR_MON_IFACE");
                        else if(resp[2]==Msg.MON_IFACE_NOT_ENABLED)
                            errmsg=bundle.getString("ERR_MON_IFACE_DOWN");
                        else
                            errmsg=bundle.getString("ERR_SERVER");
                    }else if(resp[1]==Msg.OK){
                        String infomsg=bundle.getString("INF_CONFIG");
                        window.reportUser(MainWindow.TYPEINFO, infomsg);
                        config.setIface(ifname);
                        config.setFCS(hasfcs);
                        config.setHeaderType(hdrindex);
                    }

                }catch(IOException io){
                    errmsg=bundle.getString("ERR_BREAKCONNECT");
                }
            }
        }

        if(errmsg!=null){
            err=bundle.getString("ERR");
            JOptionPane.showMessageDialog(window, errmsg, err,
                                          JOptionPane.ERROR_MESSAGE);
        }
    }
}
