// Injection Wizard
// --An application for injecting traffic in WEP protected Wi-Fi networks--
// Version: 1.0
// Copyright (C) 2010 Fernando Pablo Romero Navarro <fernpromero@gmail.com>
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package cliente;

import java.awt.event.*;
import java.util.ResourceBundle;
import java.io.IOException;
import java.nio.ByteBuffer;
import javax.swing.JOptionPane;


public class MenuSubnetListener implements ActionListener{
    private final static int MAXREQUEST=32;
    private MainWindow window=null;

    public MenuSubnetListener(MainWindow mainwin){
        window=mainwin;
    }

    public void actionPerformed(ActionEvent evt){
        ResourceBundle bundle=window.getBundle();
        ClientConf config=window.getConfig();
        SubnetDialog sd=new SubnetDialog(window, bundle, config);
        ByteBuffer buf=null;
        String err=null, prefix=null, errmsg=null;
        byte[] request=null, response=null;
        int offset=0, reqlen=0;

        if(sd.isValidated()){
            request=new byte[MAXREQUEST];
            offset=reqlen++;
            request[offset]=Msg.SET;
            offset=reqlen;

            prefix=sd.getSubnetPrefix();
            buf=MsgOptParser.getBytes(Msg.SUBNET);
            buf.rewind();
            reqlen+=buf.remaining();
            buf.get(request, offset, reqlen-offset);
            offset=reqlen++;
            request[offset]=Msg.VALUE_SEP;
            offset=reqlen;
            buf=MsgOptParser.getBytes(prefix);
            buf.rewind();
            reqlen+=buf.remaining();
            buf.get(request, offset, reqlen-offset);
            offset=reqlen++;
            request[offset]=Msg.ITEM_SEP;
            offset=reqlen;

            byte search=(byte)sd.getSearchType();
            buf=MsgOptParser.getBytes(Msg.SEARCH);
            buf.rewind();
            reqlen+=buf.remaining();
            buf.get(request, offset, reqlen-offset);
            offset=reqlen++;
            request[offset]=Msg.VALUE_SEP;
            offset=reqlen++;
            request[offset]=search;
            offset=reqlen++;
            request[offset]=Msg.ITEM_SEP;

            CommClient commcli=window.getCommClient();
            try{
                commcli.sendMsg(request, 0, reqlen);
                response=commcli.getResponse();
                if(response[1]==Msg.SERVER_ERROR){
                    errmsg=bundle.getString("ERR_SERVER");
                }else if(response[1]==Msg.OK){
                    String infomsg=bundle.getString("INF_CONFIG");
                    window.reportUser(MainWindow.TYPEINFO, infomsg);
                    config.setSubnet(prefix);
                    config.setSearchType(search);
                }
            }catch(IOException io){
                errmsg=bundle.getString("ERR_BREAKCONNECT");
            }


            if(errmsg!=null){
                err=bundle.getString("ERR");
                JOptionPane.showMessageDialog(window, errmsg, err,
                                            JOptionPane.ERROR_MESSAGE);
            }
        }
    }
}
